from random import choice


class Stab(object):
    def __init__(self, combat):
        """Stab (Quickest attack, low damage)"""
        self.name = "Stab"
        self.speed = 10
        self.damage_bonus = 3
        self.chance_to_slow = 0
        self.chance_to_crit = 0
        self.chance_to_miss = 0
        self.slow = 0


class PalmDrive(object):
    def __init__(self, combat):
        """Palm-drive (Medium quickness, medium damage, chance to slow)"""
        self.name = "Palm-drive"
        self.speed = 5
        self.damage_bonus = 5
        self.chance_to_slow = 0.33
        self.chance_to_crit = 0
        self.chance_to_miss = 0
        self.slow = choice(range(1-5))


class Juggular(object):
    def __init__(self, combat):
        """Juggular (Medium quickness, heavy damage, high crit chance, risky)"""
        self.name = "Juggular"
        self.speed = 4
        self.damage_bonus = 10
        self.chance_to_slow = 0
        self.chance_to_crit = .7
        self.chance_to_miss = 0.5
        self.slow = 0


class Slash(object):
    def __init__(self, combat):
        """Slash (Medium quickness, medium damage)"""
        self.name = "Slash"
        self.speed = 5
        self.damage_bonus = 6
        self.chance_to_slow = 0
        self.chance_to_crit = 0
        self.chance_to_miss = 0
        self.slow = 0


class Cleave(object):
    def __init__(self, combat):
        """Cleave (Slow quickness, heavy damage, chance to slow)"""
        self.name = "Cleave"
        self.speed = 2
        self.damage_bonus = 12
        self.chance_to_slow = .33
        self.chance_to_crit = 0
        self.chance_to_miss = 0
        self.slow = choice(range(1-5))


class Rend(object):
    def __init__(self, combat):
        """Rend (Slow quickness, heavy damage, high chance of crit)"""
        self.name = "Rend"
        self.speed = 2
        self.damage_bonus = 14
        self.chance_to_slow = 0
        self.chance_to_crit = 0.85
        self.chance_to_miss = 0
        self.slow = 0


class QuickShot(object):
    def __init__(self, combat):
        """Quick-shot (Auto-first, weak damage)"""
        self.name = "Quick-shot"
        self.speed = 999
        self.damage_bonus = 4
        self.chance_to_slow = 0
        self.chance_to_crit = 0
        self.chance_to_miss = 0
        self.slow = 0
        # Might work / might not, might have to add it into the logic of the attacks
        combat.player_pretend_def_mod += 999


class SharpShoot(object):
    def __init__(self, combat):
        """Sharp-shoot (Medium damage. Medium quickness, high chance to crit)"""
        self.name = "Sharp-shoot"
        self.speed = 5
        self.damage_bonus = 5
        self.chance_to_slow = 0
        self.chance_to_crit = 95
        self.chance_to_miss = 0
        self.slow = choice(range(1-5))


class Hamstring(object):
    def __init__(self, combat):
        """Hamstring (Low damage, Medium quickness, guarenteed slow, slightly risky)"""
        self.name = "Hamstring"
        self.speed = 5
        self.damage_bonus = 3
        self.chance_to_slow = 1
        self.chance_to_crit = 0
        self.chance_to_miss = 0.25
        self.slow = choice(range(3-5))

